#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
import locale
import urllib
import urlparse
import urllib2
import json
import time

import xbmc
import xbmcgui
import xbmcplugin
import xbmcaddon

from resources.data import config
from resources.lib import guide
from resources.lib import youtube

base_url = sys.argv[0]
addon_handle = int(sys.argv[1])
addon = xbmcaddon.Addon()

args = urlparse.parse_qs(sys.argv[2][1:])
mode = args.get('mode', None)

monitor = xbmc.Monitor()

def build_url(query):
    return base_url + '?' + urllib.urlencode(query)

def get_thumb_timestamp(minutes=15):
    return str(time.mktime(time.gmtime(minutes * 60 * (round(time.time() / (minutes * 60))))))
	
if mode is None:
	
    video_id = 'YX5F6QXs8lw'
    api_key = config.YOUTUBE_API_KEY
    request = urllib2.Request("https://www.googleapis.com/youtube/v3/videos?part=snippet&id=%s&key=%s" % (video_id, api_key))
    response = urllib2.urlopen(request)
    string_data2 = response.read()
    data = json.loads(string_data2)
    items = data["items"]
    
    for item in items:
    	title = item.get("snippet").get("title")
        description = item.get("snippet").get("description")
        thumbnail = item.get("snippet").get("thumbnails").get("standard").get("url")
    	
    title_string = '[B]' + '[COLOR FFFF0000]Live [/COLOR]' + '[COLOR FF655B5B]| [/COLOR]' + title + '[/B]'
    
    get_thumb = get_thumb_timestamp()
    thumbnail+= '?ct=' + get_thumb
    
    while monitor.onSettingsChanged():
   	Container.Refresh
   
    stream = addon.getSetting("stream")
    if stream == 'true' :
        url = "plugin://plugin.video.twitch/?mode=play&channel_id=%s" % config.TWITCH_CHANNEL_ID
    elif stream == 'false' :
        url = "plugin://plugin.video.youtube/play/?video_id=%s" % video_id
      
   
    li = xbmcgui.ListItem(title_string)
    li.setInfo(type = "video", infoLabels = { "Plot": description})
    li.setProperty("isPlayable", "true")
    li.setArt({"thumb" : thumbnail})
    li.addContextMenuItems([( 'Refresh', 'Container.Refresh' )])
    xbmcplugin.addDirectoryItem(addon_handle, url, li, False)
   
    li = xbmcgui.ListItem('Mediathek', thumbnailImage = config.img1)
    url = "plugin://plugin.video.youtube/user/%s/" % config.CHANNEL_ID
    xbmcplugin.addDirectoryItem(addon_handle, url, li, True)

    li = xbmcgui.ListItem('Let\'s-Play-Mediathek', iconImage = config.img2)
    url = "plugin://plugin.video.youtube/channel/%s/" % config.LETS_PLAY_CHANNEL_ID
    xbmcplugin.addDirectoryItem(addon_handle, url, li, True)

    li = xbmcgui.ListItem('Hängi-Hauptquartier', thumbnailImage = config.img3)
    url = "plugin://plugin.video.youtube/channel/%s/" % config.LETS_PLAY_CHANNEL2_ID
    xbmcplugin.addDirectoryItem(addon_handle, url, li, True)
    
    li = xbmcgui.ListItem('KINO+', thumbnailImage = config.img6)
    url = "plugin://plugin.video.youtube/channel/%s/" % config.KINO_PLUS_ID
    xbmcplugin.addDirectoryItem(addon_handle, url, li, True)
   
    li = xbmcgui.ListItem('Game Two', thumbnailImage = config.img4)
    url = "plugin://plugin.video.youtube/channel/%s/" % config.GAMETWO_ID
    xbmcplugin.addDirectoryItem(addon_handle, url, li, True)
    
    li = xbmcgui.ListItem('Twitch VOD', thumbnailImage = config.img5)
    url = "plugin://plugin.video.twitch/?mode=channel_video_list&broadcast_type=upload&channel_id=%s" % config.TWITCH_CHANNEL_ID
    xbmcplugin.addDirectoryItem(addon_handle, url, li, True)

    li = xbmcgui.ListItem(label='[B]' + 'Sendeplan' + '[/B]')
    url = build_url({'mode': 'guide'})
    xbmcplugin.addDirectoryItem(addon_handle, url, li, True)

elif mode[0] == 'guide':
    guide_items = guide.show_guide(addon_handle)

    for guide_item in guide_items:
        li = xbmcgui.ListItem(guide_item)
        xbmcplugin.addDirectoryItem(addon_handle, '', li)

xbmcplugin.endOfDirectory(addon_handle)
