import datetime
import json
import time
import urllib2

from resources.data import config

def show_guide(addon_handle):
    items = []

    request = urllib2.Request(config.GUIDE_URL, headers={'User-Agent':'Kodi'})
    response = urllib2.urlopen(request)
    string_data = response.read()

    data = json.loads(string_data)
    schedule = data['schedule']

    cur_date = None
    for item in schedule:
        startTime = datetime.datetime(*time.strptime(item['timeStart'][:19], "%Y-%m-%dT%H:%M:%S")[:6])
        title = item['title']
        type = item['type']
        topic = item['topic']

        if cur_date is None:
            cur_date = startTime.date()
        elif (startTime.date() - cur_date).days != 0:
            items.append(startTime.strftime('[B]' + '________________________ %A, %d. %B ________________________' + '[/B]'))
            cur_date = startTime.date()

        if not type:
            type_string = ''
        else:
            type_name = type[0].upper() + type[1:]
            if type == 'live':
                type_string = '[B][COLOR FFFF0000][' + type_name + '][/COLOR][/B]'
            elif type == 'premiere':
                type_string = '[COLOR FF00BFFF][' + type_name + '][/COLOR]'
            else:
                type_string = type_name

        
        title_string = '[B]' + title + '[/B]'
        
        if not topic:
        	topic_string = ''
        else:
        	topic_string = '(' + topic + ')'               
      
                
        items.append(startTime.strftime('%H:%M ') + title_string + ' ' + type_string + ' ' + topic_string )

    return items
